/****************************************************************************

 ■PhotoFrame
	アプリケーション
        Copyright(C) 2018 Denshi Usagi

****************************************************************************/

#ifndef APPLICATION_H
#define APPLICATION_H

#include "Display.h"
#include "Scaduler.h"
#include "PhotoList.h"
#include "Weather.h"
#include "Kosa.h"
#include "SDL_mixer.h"

class CApplication
{
public:
	CApplication();
	
	bool Initialize(void);
	void Finalize(void);
	int Process(void);

private:
	bool PumpMessage(void);
	void PhotoDisplay(void);
	void SpecialPhoto(const String* pInfo);
	void StartupSound(void);
	void PlaySound(const String* pInfo);

private:
	CDisplay m_Display;
	CScaduler m_Scaduler;
	CPhotoList m_PhotoList;
	CWeather m_Weather;
	CKosa m_Kosa;
	Mix_Music* m_pMusic;

	int m_nStatePhoto;
	int m_nStateSpecial;
	int m_nNextTime;
	bool m_bDisplayed;
	bool m_bStartup;
};

#endif /* APPLICATION_H */
