/****************************************************************************

 ■PhotoFrame
    制御基板の抽象化
        Copyright(C) 2018 Denshi Usagi

****************************************************************************/

#include "CtrlBoard.h"
#include "SDL2/SDL.h"
#include <wiringPi.h>

#define GPIO9   9
#define GPIO10  10
#define GPIO11  11

//---------------------------------------------------------------------------

// ●初期化
bool CCtrlBoard::Initialize(void)
{
    if (wiringPiSetupGpio() == -1)
        return false;
    
    pinMode(GPIO9, OUTPUT);
    pinMode(GPIO10, OUTPUT);
    pinMode(GPIO11, INPUT);

    return true;
}

// ●LCD制御(GPIO:09 →LCD制御)
void CCtrlBoard::EnablePanel(bool bEnable)
{
    if (digitalRead(GPIO9) != bEnable)
	{
		digitalWrite(GPIO9, (bEnable)? HIGH : LOW);
		SDL_Delay(3000);
	}
}

// ●終了通知(GPIO:10 →終了通知)
void CCtrlBoard::NotifyEixt(void)
{
    digitalWrite(GPIO10, HIGH);
}

// ●終了指示が出ているかを調べる(GPIO:11 ←終了指示)
bool CCtrlBoard::IsStop(void)
{
    return (digitalRead(GPIO11) != LOW);
}
