/****************************************************************************

 ■PhotoFrame
	表示クラス
		Copyright(C) 2018 Denshi Usagi

****************************************************************************/

#ifndef CDISPLAY_H
#define CDISPLAY_H

#include "TypeDefs.h"
#include "SDL2/SDL.h"

struct SWeather;
struct SKosa;

#define DISP_W	1536
#define DISP_H	2048
#define PART_L	256
#define PART_X	(DISP_W / PART_L)
#define PART_Y	(DISP_H / PART_L)

#define FONT_DEFAULT	"/usr/share/fonts/truetype/mfont/mplus-2p-medium.ttf"

class CDisplay
{
public:
    CDisplay();
	
	bool Create(void);
	void Destroy(void);
	void DisplayImage(PCSTR pFile);
	void DisplayCalender(double dTempture);
	void DisplayWeather(const SWeather* pWeather);
	void DisplayKosa(const SKosa* pKosa);
	void Ending(void);

private:
	int GetWeekdayType(struct tm* p);
	bool IsHolyday(struct tm* p);
	bool IsFurikae(struct tm* p);
	SDL_Surface* LeftRotation(SDL_Surface* pSurface);
	void DrawText(SDL_Surface* pDraw, int x, int y, int nSize, SDL_Color& col, PCSTR pText, PCSTR pFontName = FONT_DEFAULT);
	void DrawText(SDL_Surface* pDraw, SDL_Rect* pRect, int nSize, SDL_Color& col, PCSTR pText, PCSTR pFontName = FONT_DEFAULT);
	void Display(SDL_Surface* pSurface);
	void Present1(void);
	void Present2(void);
	void Present3(void);
	void SetupState(int nStage);

private:
	SDL_Window* m_pWnd;
	SDL_Surface* m_pSurface;
	SDL_Surface* m_Parts[2][PART_X][PART_Y];
	int m_Idxes[2];
	int m_nStage;
	int m_nFlip[100];
};

#endif /* CDISPLAY_H */
