/****************************************************************************

 ■PhotoFrame
	黄砂情報
        Copyright(C) 2021 Denshi Usagi

****************************************************************************/

#ifndef KOSA_H
#define KOSA_H

#include <openssl/ssl.h>
#include "TypeDefs.h"

struct SKosa
{
	int nDay1; // 1日目の日
	int nDay2; // 2日目の日
	int Kosa_Detail[8]; // 黄砂 6時間ごと×2日分
	int Kosa_Weekly[7]; // 黄砂 7日分
	int PM25_Detail[8]; // PM2.5 6時間ごと×2日分
	int PM25_Weekly[7]; // PM2.5 7日分
};

class CKosa
{
public:
	CKosa();

	void Initialize(void);
	void Update(void);
	bool IsEnable(void);
	const SKosa* GetKosa(void);

private:
	int Request(PCSTR pQuery, PSTR& pBuf, int nSize);
	int ParseHtml(void);
	void EndRequest(void);
	bool Search(PSTR& pBuf, PCSTR pKey);
	bool GetValue(PSTR& pBuf, PCSTR pKey1, PCSTR pKey2, int& var);

private:
	String m_strHost;
	String m_strQuery;
	bool m_bEnable;
	SKosa m_Kosa;

	int m_Socket;
	SSL_CTX* m_pCtx;
	SSL* m_pSSL;

	time_t m_tLast;
	PSTR m_pBuf;
};

#endif /* KOSA_H */
