/****************************************************************************

 ■PhotoFrame
	スケジューラ
        Copyright(C) 2018 Denshi Usagi

****************************************************************************/

#ifndef SCADULER_H
#define SCADULER_H

#include "TypeDefs.h"
#include "RTC.h"
#include <vector>
#include <time.h>

// スケジュール
enum EScadule
{
	SC_PotoDisplay,		// 通常動作
	SC_SpecialPhoto,	// 特別動作(特別写真)
	SC_PlaySound,		// 特別動作(サウンド再生)
	SC_Wait,			// 時間が来るまで待つ(制御用)
	SC_Ending,			// 終了(スケジュールなし)(制御用)
};

// スケジュール情報
struct SScadule
{
	EScadule eType;
	String sName;
	String sTime;
	String sInfo;
	time_t tNext;
	time_t tLast;
};

typedef std::vector<SScadule*> scd_vect;

class CScaduler
{
public:
	CScaduler();
	~CScaduler();

	bool Initialize(void);
	EScadule Scadule(String* pInfo);
	void Complete(void);
	inline double GetTempture(void) { m_RTC.GetTempture(); }

private:
	void Load(void);
	void LoadPhoto(void);
	void LoadSpecial(PCSTR pNameBase, EScadule eType, time_t tCurrent);
	int Next(time_t tCurrent);
	int CalcNext(bool bFuture, time_t tCurrent);
	void NextPhoto(SScadule* pScadule, bool bFuture, time_t tCurrent);
	void NextSpecial(SScadule* pScadule);
	int GetClosestTime(void);

private:
	scd_vect m_List;
	int m_Current;
	CRTC m_RTC;
};

#endif /* SCADULER_H */
