/****************************************************************************

 ■PhotoFrame
	天気情報
        Copyright(C) 2018 Denshi Usagi

****************************************************************************/

#ifndef WEATHER_H
#define WEATHER_H

#include <openssl/ssl.h>
#include "TypeDefs.h"

// 1時間ごとの天気
struct SWeatherDetail
{
	int nHour;	// 時間
	int nTenki;	// 天気
	int nKion;	// 気温
	int nKosui;	// 降水量
};
// 週間天気予報
struct SWeatherWeekly
{
	int nDay;	// 日
	int nTenki;	// 天気
	int nKion;	// 最高気温
	int nKosui;	// 降水確率
};
struct SWeather
{
	SWeatherDetail Detail[24];
	SWeatherWeekly Weekly[10];
};

class CWeather
{
public:
	CWeather();

	void Initialize(void);
	void Update(void);
	bool IsEnable(void);
	const SWeather* GetWeather(void);

private:
	int Request(PCSTR pQuery, PSTR& pBuf, int nSize);
	int ParseHtml(void);
	void EndRequest(void);
	bool Search(PSTR& pBuf, PCSTR pKey);
	bool GetValue(PSTR& pBuf, PCSTR pKey1, PCSTR pKey2, int& var);
	void RemoveStr(PSTR pDst, PSTR pSrc, PCSTR pKey);

private:
	String m_strHost;
	String m_strQuery1;
	String m_strQuery2;
	bool m_bEnable;
	SWeather m_Weather;

	int m_Socket;
	SSL_CTX* m_pCtx;
	SSL* m_pSSL;
    
	time_t m_tLast;
	PSTR m_pBuf1;
	PSTR m_pBuf2;
};

#endif /* WEATHER_H */
